<template>
  <div class="select-executor">
     <ObAutocomplete
        ref="executorSelect"
        :value="value"
        label="Исполнитель"
        placeholder="Поиск исполнителя"
        theme="blue"
        :remote-opt="selectExecutorDropdown()"
        :is-disabled="isClient || isDisabled"
        :is-always-action="isAlwaysAction"
        :action-icon="true"
        :is-init-list-after-select="true"
        popper-class="order-executor-select"
        data-qa="executor"
        @selectAction="modalOpen()"
        @input="onChangeExecutor"
     >
       <div
         class="d-f jc-sb a-i-c w100 flex-grow"
         slot="item"
         slot-scope="{ data, highlight }"
       >
         <div
           v-html="highlight(data.title)"
           class="item-title"
           :class="data.isDisabled && '-gray-window'"
         />
         <div
           class="item-executor -gray-window"
           :title="data.executorName"
         >
           {{ data.executorName || '' }}
         </div>
         <div class="item-inn -gray-window">
           {{ data.executorInn ? 'инн ' + data.executorInn : '' }}
         </div>
         <div class="item-loading -gray-window">
           {{ data.executorLoadingDate ? 'отг ' + formatDate(data.executorLoadingDate) : '' }}
         </div>
         <div class="item-nds -gray-window">
           {{ data.isVatPayer ? 'тариф с ндс' : 'тариф без ндс' }}
         </div>
         <div
           class="item-tariff"
           :class="data.isDisabled && '-gray-window'"
         >
           <template v-if="data.tripTariff">
             {{ data.tripTariff / 100 | currency({ dot: 2 }) }} ₽
           </template>
           <template v-else>
             <span class="-gray-window">
              нет договора
             </span>
           </template>
         </div>
       </div>
       <template
         v-if="Boolean(bookingCount)"
         slot="extraIcon"
       >
         <span class="booking-count">
           {{ bookingCount }}
         </span>
       </template>
     </ObAutocomplete>
     <button
       v-if="isAuto && isNew"
       class="select-executor__approaching"
       @click="approachingModalOpen"
     >
       <img src="./icons/krugoreis.svg" alt="">
     </button>
      <ob-modal
        ref="selectExecutorTable"
        title="Подбор перевозчиков"
        size="extra-large"
        :is-show-controls="true"
        :is-read-only="true"
        data-qa="selectExecutorModal"
      >
        <SelectExecutorTableModal
          ref="executorTableModal"
          @on-select="onSelect"
          @on-cancel-executor="onCancelExecutor"
          :value="value"
        />
      </ob-modal>
      <ApproachingModal
        ref="approachingModal"
        :order="selectedSubOrder"
      />
  </div>
</template>

<script>
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObAutocomplete from 'common-components/src/obComponents/obAutocomplete'
  import SelectExecutorTableModal from './modals/selectExecutorTableModal'
  import ApproachingModal from './../modal/ApproachingModal'
  import api from '@/api'
  import moment from 'moment'

  export default {
    components: {
      SelectExecutorTableModal,
      ObModal,
      ObAutocomplete,
      ApproachingModal
    },
    props: {
      value: {
        type: Object,
        default: null
      },
      isClient: {
        type: Boolean,
        default: false
      },
      isDisabled: {
        type: Boolean,
        default: false
      },
      selectedSubOrder: {
        type: Object,
        default: () => {}
      },
      actionIcon: {
        type: Boolean,
        default: false
      },
      bookingCount: {
        type: Number,
        default: 0
      },
      isAlwaysAction: {
        type: Boolean,
        default: false
      }
    },
    computed: {
      orderId () {
        return this.$route.params.id
      },
      isAuto () {
        return this.selectedSubOrder?.transportationWay === 'FTL'
      },
      isNew () {
        return this.selectedSubOrder.status === 'NEW' || this.selectedSubOrder.status === 'ON_DOER_SEARCH'
      }
    },
    methods: {
      selectExecutorDropdown () {
        return {
          method: api.orderProcess.getExecutorsListAll,
          arguments: {
            uuid: this.selectedSubOrder.uuid,
            species: this.selectedSubOrder.species
          }
        }
      },
      onChangeExecutor(data) {
        this.$emit('input', data)
        this.$emit('onChangeExecutor', data)
      },
      onSelect(data) {
        this.modalClose()
        this.$emit('on-select',  data)
      },
      onCancelExecutor () {
        this.modalClose()
        this.$emit('on-cancel-executor')
      },
      modalOpen () {
        this.$refs.selectExecutorTable.open()
        this.$refs.executorTableModal && this.$refs.executorTableModal.loadData()
      },
      modalClose () {
        this.$refs.selectExecutorTable.close()
      },
      formatDate (date) {
        return date ? moment(date).format('DD.MM.yy') : ''
      },
      approachingModalOpen () {
        this.$refs.approachingModal?.open()
      }
    }
  }
</script>

<style lang="scss">
  .order-executor-select {
    .item-title {
      width: 200px;
      flex-shrink: 0;
      flex-grow: 2;
      margin-right: 15px;
      overflow: hidden;
      white-space: nowrap;
      text-overflow: ellipsis;
    }
    .item-executor {
      width: 200px;
      overflow: hidden;
      white-space: nowrap;
      text-overflow: ellipsis;
      margin-right: 15px;
      text-align: left;
      font-size: 0.8em;
    }
    .item-inn {
      flex-shrink: 0;
      width: 120px;
      margin-right: 15px;
      text-transform: uppercase;
      font-size: 0.8em;
      text-align: right;
    }
    .item-loading {
      flex-shrink: 0;
      margin-right: 15px;
      text-transform: uppercase;
      font-size: 0.8em;
      text-align: right;
    }
    .flex-grow {
      flex-grow: 2;
    }
    .item-nds {
      flex-shrink: 0;
      font-size: 0.9em;
      width: 120px;
    }
    .item-tariff {
      flex-shrink: 0;
      width: 120px;
    }
  }
</style>
<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .select-executor {
    position: relative;
    &__approaching {
      opacity: 0;
      position: absolute;
      top: 22px;
      right: 60px;
      background: transparent;
      border: none;
      outline: none;
      cursor: pointer;
      transition: opacity .2s;
      &:hover {
        opacity: 0.8;
      }
    }
    &:hover {
      .select-executor__approaching {
        opacity: 1;
      }
    }
  }
  .booking-count {
    display: flex;
    justify-content: center;
    align-items: center;
    text-align: center;
    margin-left: 15px;
    width: 24px;
    height: 24px;
    background-color: $color-error;
    border-radius: 50%;
    @include font-mixin(12px, 16px, 600, $background-white, 0.2px);
  }
</style>
